## ros-kinetic-realsense2-camera 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(realsense2_camera)
add_compile_options(-std=c++11)

option(BUILD_WITH_OPENMP "Use OpenMP" OFF)
option(SET_USER_BREAK_AT_STARTUP "Set user wait point in startup (for debug)" OFF)

add_definitions(-D_CRT_SECURE_NO_WARNINGS)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

find_package(catkin REQUIRED COMPONENTS
    message_generation
    nav_msgs
    roscpp
    sensor_msgs
    std_msgs
    std_srvs
    nodelet
    cv_bridge
    image_transport
    tf
    ddynamic_reconfigure
    diagnostic_updater
    )

if(BUILD_WITH_OPENMP)
    find_package(OpenMP)
    if(NOT OpenMP_FOUND)
        message(FATAL_ERROR "\n\n OpenMP is missing!\n\n")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -fopenmp")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    endif()
endif()

if(SET_USER_BREAK_AT_STARTUP)
	message("GOT FLAG IN CmakeLists.txt")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBPDEBUG")
endif()

if (WIN32)
find_package(realsense2 CONFIG REQUIRED)
else()
find_package(realsense2 2.45.0)
endif()

if(NOT realsense2_FOUND)
    message(FATAL_ERROR "\n\n Intel RealSense SDK 2.0 is missing, please install it from https://github.com/IntelRealSense/librealsense/releases\n\n")
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (${uppercase_CMAKE_BUILD_TYPE} STREQUAL "RELEASE")
    message(STATUS "Create Release Build.")
    set(CMAKE_CXX_FLAGS "-O2 ${CMAKE_CXX_FLAGS}")
else()
    message(STATUS "Create Debug Build.")
endif()

if (WIN32)
else()
set(CMAKE_CXX_FLAGS "-fPIE -fPIC -std=c++11 -D_FORTIFY_SOURCE=2 -fstack-protector -Wformat -Wformat-security -Wall ${CMAKE_CXX_FLAGS}")
endif()

add_message_files(
    FILES
    IMUInfo.msg
    Extrinsics.msg
    )

generate_messages(
    DEPENDENCIES
    sensor_msgs
    std_msgs
    )

set(CMAKE_NO_SYSTEM_FROM_IMPORTED true)
include_directories(
    include
    ${realsense2_INCLUDE_DIR}
    ${catkin_INCLUDE_DIRS}
    )

# RealSense ROS Node
catkin_package(
    LIBRARIES ${PROJECT_NAME}
    CATKIN_DEPENDS message_runtime roscpp sensor_msgs std_msgs
    nodelet
    cv_bridge
    image_transport
    ddynamic_reconfigure
    nav_msgs
    )

add_library(${PROJECT_NAME}
    include/constants.h
    include/realsense_node_factory.h
    include/base_realsense_node.h
    include/t265_realsense_node.h
    src/realsense_node_factory.cpp
    src/base_realsense_node.cpp
    src/t265_realsense_node.cpp
    )

add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_generate_messages_cpp)
add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})

target_include_directories(${PROJECT_NAME}
  PRIVATE ${realsense2_INCLUDE_DIR})

target_link_libraries(${PROJECT_NAME}
    ${realsense2_LIBRARY}
    ${catkin_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    )

if(WIN32)
set_target_properties(${realsense2_LIBRARY} PROPERTIES MAP_IMPORTED_CONFIG_RELWITHDEBINFO RELEASE)
target_link_libraries(${PROJECT_NAME}
    realsense2::realsense2 
    realsense2::realsense-file
    )
endif()


# Install nodelet library
install(TARGETS ${PROJECT_NAME}
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    )

# Install header files
install(DIRECTORY include/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
    )

# Install launch files
install(DIRECTORY launch/
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
    )

# Install rviz files
install(DIRECTORY rviz/
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/rviz
    )

# Install xml files
install(FILES nodelet_plugins.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
    )

=== debian/changelog ===
ros-kinetic-realsense2-camera (2.3.0-1xenial) xenial; urgency=high

  * Fix pointcloud message size when no texture is added.
  * Added filling correct Tx, Ty values in projection matrix of right camera.
  * Fixed frame_id of right sensor to match left sensor in a stereo pair.pair
  * Contributors: Pavlo Kolomiiets, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 04 May 2021 21:00:00 -0000

ros-kinetic-realsense2-camera (2.2.24-1xenial) xenial; urgency=high

  * Enabling pointcloud while align_depth is set to true creates a pointcloud aligned to color image.
  * Removed option to align depth to other streams other then color.
  * Contributors: doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 20 Apr 2021 21:00:00 -0000

ros-kinetic-realsense2-camera (2.2.23-1xenial) xenial; urgency=high

  * Remove the following tests for known playback issue with librealsense2 version 2.43.0: points_cloud_1, align_depth_color_1, align_depth_ir1_1, align_depth_ir1_decimation_1.
  * Add filter: HDR_merge
  * add default values to infra stream in rs_camera.launch as non are defined in librealsense2.
  * fix bug: selection of profile disregarded stream index.
  * fix initialization of colorizer inner image
  * Contributors: doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 23 Mar 2021 22:00:00 -0000

ros-kinetic-realsense2-camera (2.2.22-1xenial) xenial; urgency=high

  * Add reset service.
  * fix timestamp domain issues
    - Add offset to ros_time only if device uses hardware-clock. Otherwise use device time - either system_time or global_time.
    - Warn of a hardware timestamp possible loop.
  * Choose the default profile in case of an invalid request.
  * Avoid aligning confidence image.
  * Add an option for an Ordered PointCloud.
  * Contributors: Isaac I.Y. Saito, Itamar Eliakim, Marc Alban, doronhi

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Wed, 17 Feb 2021 22:00:00 -0000

ros-kinetic-realsense2-camera (2.2.21-1xenial) xenial; urgency=high

  * Publish depth confidence image for supporting devices (L515)
  * fix reading json file with device other than D400 series.
  * remove (temporarily) flaky IMU unit-test.
  * Contributors: Isaac I.Y. Saito, doronhi

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Wed, 30 Dec 2020 22:00:00 -0000

ros-kinetic-realsense2-camera (2.2.20-1xenial) xenial; urgency=high

  * Add Support - Noetic
  * Add demo for using intrinsics from camera_info (show_center_depth.py).
  * Add launch option: send logs to ros log file.
  * Add feature: get rgb stream from infrared sensor (applies to D415)
  * Add feature: Add notification if connected using USB2.1 port.
  * Fix bug: Avoid z16h format
  * Fix bug: monitor streams frequency without subsribing.
  * Fix bug: extrinsincs for right stereo camera refers to the left stereo camera.
  * Contributors: Abhijit Majumdar, Isaac I. Y. Saito, Jakub, M-frctrl, Thomas Jespersen, doronhi

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Wed, 18 Nov 2020 22:00:00 -0000

ros-kinetic-realsense2-camera (2.2.18-1xenial) xenial; urgency=high

  * Fix bug: Remove parameter with invalid value.
  * Fix bug: Colorize the aligned depth image.
  * Fix bug: Added pointcloud attributes, when RS2_STREAM_ANY is enabled
  * Add feature: enable/disable all sensors. Known issues: parameters persistency and not full power drop.

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Sun, 25 Oct 2020 22:00:00 -0000

ros-kinetic-realsense2-camera (2.2.17-1xenial) xenial; urgency=high

  * Fix for ROS on Windows
  * Contributors: Lou Amadio, doronhi

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Tue, 08 Sep 2020 21:00:00 -0000

ros-kinetic-realsense2-camera (2.2.16-1xenial) xenial; urgency=high

  * Add PID to support D455.
  * Improve instability of dynamic reconfigurable options.
  * rs_camera.lauch: add "enable_infra" for L515 support.
  * Contributors: doronhi

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Wed, 05 Aug 2020 21:00:00 -0000

ros-kinetic-realsense2-camera (2.2.15-1xenial) xenial; urgency=high

  * Check runtime version of librealsense2 vs. compiled version and issue a warning is mismatch occurs.
  * Support both L515 and L515 pre-prq versions.
  * set infra, fisheye, IMU and pose streams to be false by default.
  * add d435i-xacro
  * comply to ROS Noetic xacro rules (backcompatible with ROS Melodic)
  * Contributors: Marco Camurri, doronhi

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Sun, 12 Jul 2020 21:00:00 -0000

ros-kinetic-realsense2-camera (2.2.14-1xenial) xenial; urgency=high

  * Fix compatibility with Librealsense2 Version 2.35.2.
  * Fix support for L515.
  * Fix urdf issues.
  * Add noetic support: change state_publisher into robot_state_publisher
  * fix distortion correction model for T265 (equidistant)
  * fix stability issues. Stop sensors at program termination.
  * Contributors: Brice, Helen Oleynikova, doronhi
  * upgrade version to 2.2.13
  * fix ctrl-C closing issues.
  * handle device creation exceptions.
  * support LiDAR camera L515.
  * optimize pointcloud. Contributors: Davide Faconti
  * fix usb port id parsing issues.
  * Add eigen dependency - missing for Melodic. Contributors: Antoine Hoarau

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Wed, 17 Jun 2020 21:00:00 -0000

=== debian/control ===
Source: ros-kinetic-realsense2-camera
Section: misc
Priority: optional
Maintainer: Doron Hirshberg <doron.hirshberg@intel.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-kinetic-catkin, ros-kinetic-cv-bridge, ros-kinetic-ddynamic-reconfigure, ros-kinetic-diagnostic-updater, ros-kinetic-genmsg, ros-kinetic-image-transport, ros-kinetic-librealsense2, ros-kinetic-message-runtime, ros-kinetic-nav-msgs, ros-kinetic-nodelet, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf
Homepage: http://www.ros.org/wiki/RealSense
Standards-Version: 3.9.2

Package: ros-kinetic-realsense2-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-kinetic-cv-bridge, ros-kinetic-ddynamic-reconfigure, ros-kinetic-diagnostic-updater, ros-kinetic-genmsg, ros-kinetic-image-transport, ros-kinetic-librealsense2, ros-kinetic-message-runtime, ros-kinetic-nav-msgs, ros-kinetic-nodelet, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf
Description: RealSense Camera package allowing access to Intel T265 Tracking module and SR300 and D400 3D cameras

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-realsense2-camera//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
